unit stepeditform;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls, taskfile;

type

  { TStepEdit_Form }

  TStepEdit_Form = class(TForm)
    Help_Button: TButton;
    Cancel_Button: TButton;
    OK_Button: TButton;
    Delay_Edit: TEdit;
    Text_Memo: TMemo;
    VariableName_Edit: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Title_Edit: TEdit;
    Label1: TLabel;
    Type_Group: TRadioGroup;
    procedure DataChange(Sender: TObject);
    procedure Help_ButtonClick(Sender: TObject);
    procedure OnShow(Sender: TObject);
  private
    procedure EnableControls;
    procedure Validate;
  public
    NewRec: boolean;
    procedure setData(Step: TStep);
    function getData: TStep;
  end;

var
  StepEdit_Form: TStepEdit_Form;

implementation

{$R *.lfm}

uses helpform;

{ TStepEdit_Form }

procedure TStepEdit_Form.EnableControls;
begin
  if Type_Group.ItemIndex = 0 then
  begin
    Delay_Edit.Enabled := True;
    Text_Memo.Enabled := True;
    VariableName_Edit.Enabled := False;
  end
  else if Type_Group.ItemIndex = 1 then
  begin
    Delay_Edit.Enabled := True;
    Text_Memo.Enabled := True;
    VariableName_Edit.Enabled := False;
  end
  else if Type_Group.ItemIndex = 2 then
  begin
    Delay_Edit.Enabled := False;
    Text_Memo.Enabled := False;
    VariableName_Edit.Enabled := True;
  end;
end;

procedure TStepEdit_Form.Validate;
var
  i, Code: integer;
begin
  Val(Delay_Edit.Text, i, Code);
  OK_Button.Enabled := (Title_Edit.Text <> '') and
    (((Type_Group.ItemIndex = 0) and (Text_Memo.Text <> '') and (Code = 0)) or
    ((Type_Group.ItemIndex = 1) and (Text_Memo.Text <> '') and (Code = 0)) or
    ((Type_Group.ItemIndex = 2) and (VariableName_Edit.Text <> '')));
end;

procedure TStepEdit_Form.OnShow(Sender: TObject);
begin
  if NewRec then
  begin
    Caption := 'Создание шага';
    Type_Group.ItemIndex := 0;
    Title_Edit.Text := '';
    Delay_Edit.Text := '';
    VariableName_Edit.Text := '';
    Text_Memo.Text := '';
  end
  else
    Caption := 'Редактирование шага';
  EnableControls;
  Validate;
end;

procedure TStepEdit_Form.DataChange(Sender: TObject);
begin
  Validate;
  EnableControls;
end;

procedure TStepEdit_Form.Help_ButtonClick(Sender: TObject);
begin
  Help_Form.displayHelp(3);
end;

procedure TStepEdit_Form.setData(Step: TStep);
begin
  Delay_Edit.Text := IntToStr(Step.Delay);
  Text_Memo.Text := Step.TextToCopy;
  VariableName_Edit.Text := Step.VariableName;
  Title_Edit.Text := Step.Title;
  Type_Group.ItemIndex := Step.StepType;
  EnableControls;
  Validate;
end;

function TStepEdit_Form.getData: TStep;
var
  Code: integer;
begin
  Val(Delay_Edit.Text, Result.Delay, Code);
  if Code <> 0 then
    Result.Delay := 0;
  Result.TextToCopy := Text_Memo.Text;
  Result.StepType := Type_Group.ItemIndex;
  Result.Title := Title_Edit.Text;
  Result.VariableName := VariableName_Edit.Text;
end;

end.
